Ruby - Bug #5439
Bug # 5350 (Closed): WeakRef 1] NoMethodError

r333610 0 sample/test.rb:systemi FO [ [
10/13/2011 01:48 PM - ngoto (Naohisa Goto)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: 1.9.x Backport:

Description

r33361DDDDDDDCCDDDDDDDDDDDDDDDDDDﬂfinalizerﬂﬂDDDDDﬂﬂsample/test.rb:system OrFioooo
(Solaris 10, sparc, Sun Studio 11 0000)

% make test

(@0)

sample/test.rb:eval ........cccoovieiiiinens
sample/test.rb:system .FFFF.F.

sample/test.rb:const .....

(@0)

sample/test.rb:path .......cocoveeeenee.

sample/test.rb:gc ....make: *** [yes-test-sample] Error 1

FOO0000DO000D00000

test_ok(./miniruby -e 'print "foobar™ == 'foobar’)

r3336100000000002000000000000
if (ATOMIC_SET (finalizing, 1)) return;
000 aAtomic_seT() D0gecl000Windowsl )l

define ATOMIC_SET(var, val) __sync_lock_test_and_set(&(var), (val))

000000nttp:/gce.gnu.org/onlinedocs/gec/Atomic-Builtins.htmi 000000000

returns the previous contents of *ptr.
00000000000000000D000000000
gecll0wiNa20(Solarislecl)IO0

define ATOMIC_SET(var, val) ((var) = (val))

000000000000000000DooO00n

if (ATOMIC_SET finalizing, 1)) return;

HATOMIC_SET(finalizing, 1)[100100000000return00000000
00000000finalizerD00000000000000000r_io_fptr_finalize000000000000000000000000000FO000DDDOOO0

Associated revisions

Revision c180eabf - 10/13/2011 09:04 AM - nobu (Nobuyoshi Nakada)

® gc.c (rb_gc_finalize_deferred, rb_objspace_call_finalizer):
should use ATOMIC_EXCHANGE() to check the previous value.
[ruby-dev:44596] [Bug #5439]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@33460 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 123645aa - 10/13/2011 09:19 AM - kosaki (Motohiro KOSAKI)

e atomic.h(ATOMIC_SET): add cast to void to prevent misuse.
[ruby-dev:44596] [Bug #5439]
http://gcc.gnu.org/onlinedocs/gcc/Atomic-Builtins.html

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@33462 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 5558de40 - 10/13/2011 10:39 AM - ngoto (Naohisa Goto)

e atomic.h (ATOMIC_*): use atomic_ops(3C) when SunStudio on Solaris.
[ruby-dev:44596] [Bug #5439]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@33463 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision c96c193e - 10/13/2011 08:58 PM - nobu (Nobuyoshi Nakada)

e atomic.h (ATOMIC_INC, ATOMIC_DEC): return old values.
[ruby-dev:44596] [Bug #5439]

e signal.c (ruby_atomic_exchange): no needs to define on the
platforms where atomic.h is available.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@33464 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 2e574a5315e611ae2f5375bffb3827c64e1a0f17 - 01/30/2014 10:11 AM - U.Nakamura
merge revision(s) 33361,33460: [Backport #9463]

* gc.c (slot_sweep, rb_gc_finalize_deferred)
(rb_objspace_call_finalizer, rb_gc): run finalizers
sequencially. [ruby-dev:44562]

* gc.c (rb_gc_finalize_deferred, rb_objspace_call_finalizer):
should use ATOMIC_EXCHANGE () to check the previous value.
[ruby—-dev:44596] [Bug #5439]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9_3@44762 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 2e574a53 - 01/30/2014 10:11 AM - U.Nakamura
merge revision(s) 33361,33460: [Backport #9463]

* gc.c (slot_sweep, rb_gc_finalize_deferred)
(rb_objspace_call_finalizer, rb_gc): run finalizers
sequencially. [ruby-dev:44562]

* gc.c (rb_gc_finalize_deferred, rb_objspace_call finalizer):
should use ATOMIC_EXCHANGE () to check the previous value.
[ruby-dev:44596] [Bug #5439]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9 3@44762 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 10/13/2011 03:12 PM - shyouhei (Shyouhei Urabe)

0000000000000000000000000000000sparcllccllatomic test and setll000000000000000000000000)00000000000000007

000o00ooonoooooobonnoooDonDa

#2 - 10/13/2011 03:13 PM - kosaki (Motohiro KOSAKI)
0000000000000 ATOMIC_EXCHANGE 00000000

00000000000000000

l0aTomic_seTl void 0000000000000000000000000000000000
000000000000 atomic_sec O aATomic_EXCHANGEDNDD
0000atomicl0000000geclvelONONN4if defined(_ SUNPRO_cC) 0000

http://www.unix.com/man-page/OpenSolaris/9f/atomic_ops/

0000000DatemicOODODODOOD

000000000000000000000000000o0hanno0nDanDnanD
00o0bopoonooooo

#3 - 10/13/2011 03:41 PM - ngoto (Naohisa Goto)

0000atomicl0000000geclvellNONN4#it defined(_ SUNPRO_CC) 0000 http:/Awww.unix.com/man-page/OpenSolaris/9f/atomic_ops/

0000000DatemiclODODODOOD
http://www.unix.com/man-page/OpenSolaris/9f/atomic_ops/
http://www.unix.com/man-page/OpenSolaris/9f/atomic_ops/

Solaris10000000000 #include <atomic.h> 000000000penSolarisOO0000000000000000000000000Solaris10 [ atomic.h DO000000 #include
<sys/atomic.h> 00000000000

https://sites.google.com/a/diviware.com/unix/unix-page/solaris-page/solaris-man-pages/3c/atomic_ops

NetBspU000os0000,000000000000000configure000000000000000000

http://www.daemon-systems.org/man/atomic_ops.3.html

#4 - 10/13/2011 06:04 PM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Closed
- % Done changed from 0 to 100

This issue was solved with changeset r33460.
Naohisa, thank you for reporting this issue.
Your contribution to Ruby is greatly appreciated.
May Ruby be with you.
